package TWiki::Colorize;

use strict;

# $Id: F-A4381D7025BCC184BD4EE24FF6374624.pm,v 1.2 2003/06/09 13:11:18 zoso Exp $

use vars qw(@EXPORT_OK);
require Exporter;
*import = \&Exporter::import;
@EXPORT_OK = qw(makeColorVersion);

use HTML::Parser;

# Styles for word highlighting
use vars qw(@styles);
@styles = ('background-color: #ffff66', 'background-color: #a0ffff',
           'background-color: #ff9999', 'background-color: #99ff99',
	   'background-color: #ff66ff',
           'background-color: #880000; color: #ffffff',
           'background-color: #00aa00; color: #ffffff',
           'background-color: #886800; color: #ffffff',
           'background-color: #004699; color: #ffffff',
           'background-color: #990099; color: #ffffff');



sub makeColorVersion {
    my $cresult = "";
    my $text = shift ;
    my @words = @_;
    my $html_parser = HTML::Parser->new( api_version => 3,
                                         default_h => [sub{$cresult .= $_[0];}, "text"],
                                         text_h => [sub{$cresult .= colorize($_[0], @words)}, "dtext"]);

    $html_parser->parse($text);
    $html_parser->eof;
    return $cresult;
}

# Internal function, HTML::Parser helper
sub colorize {
    my ($text, @words) = @_;

    # Highlight words, if given
    my $cont = 0;
    my $style;
    foreach my $p ( @words ) {
      $style = $styles[$cont];
      $text =~ s|$p|<span style="$style">$&</span>|gi;
      $cont = 0 if( ++$cont > $#styles );
    }
    $text;
}

1;
